<template>
  <div class="auth-v1">
    <b-row class="m-0 p-0">
      <!-- Login v1 -->
      <b-col lg="8" class="p-0">
        <div
          :style="{ 'background-image': 'url(' + bgImgOne + ')' }"
          class="login-bg"
        ></div>
      </b-col>
      <b-col lg="4" class="d-flex align-items-center auth-bg">
        <div
          v-if="pageView == 0"
          class="auth-wrapper auth-v1"
          :style="{ 'background-image': 'url(' + bgImg + ')' }"
        >
          <div class="auth-inner p-0">
            <div class="misc-inner p-2 p-sm-3">
              <div class="w-100 text-center">
                <h2 class="mb-1">Link Expired!</h2>
                <p class="mb-2">
                  Oops! 😖 The requested URL was not found on this server.
                </p>
                <center>
                  <b-button class="forgot-login-btn" block @click="resetPage()">
                    Login
                  </b-button>
                </center>
                <!-- image -->
                <b-img fluid :src="imgUrl" alt="Error page" class="mt-2" />
              </div>
            </div>
          </div>
        </div>
        <div
          v-if="pageView == 1"
          class="auth-wrapper auth-v1"
          :style="{ 'background-image': 'url(' + bgImg + ')' }"
        >
          <div class="auth-inner p-0">
            <span class="brand-logo">
              <b-img :src="appLogoImage" alt="logo" class="brand-main-logo" />
            </span>
            <!-- Login v1 -->
            <b-card class="mb-0 login-card" id="loginCard">
              <!-- <h1 class="login-header">
                <span @click="resetPage()" ><IconBackHome  class="login-back-btn"  /></span>
                SET<span> your password to continue</span>
              </h1> -->
              <h1 class="login-header">
                <span @click="resetPage()"><IconBackHome class="login-back-btn" /></span>
                Set Password
                <p>User !</p>
              </h1>
              <p class="login-desc">
                Please enter password and confirm password for complete the set password
                process.
              </p>
              <template>
                <b-form class="auth-login-form mt-2" @submit.prevent="login">
                  <!-- email -->
                  <b-form-group>
                    <div class="d-flex justify-content-between">
                      <label for="password"
                        >Password <span class="text-danger"> *</span></label
                      >
                    </div>
                    <b-input-group
                      class="input-group-merge"
                      :class="errors.password?.length > 0 ? 'is-invalid' : null"
                    >
                      <b-form-input
                        id="forgot-password"
                        v-model="password"
                        class="text-transform-none form-control-merge"
                        :type="passwordFieldType"
                        name="forgot-password"
                        placeholder="Enter Password"
                        :state="
                          errors.password && errors.password.length > 0 ? false : null
                        "
                        @input="checkValidation('password')"
                        @blur="checkValidation('password')"
                      />
                      <b-input-group-append is-text @click="togglePasswordVisibility">
                        <svg
                          xmlns="http://www.w3.org/2000/svg"
                          v-if="passwordFieldType === 'password'"
                          width="14px"
                          height="14px"
                          viewBox="0 0 24 24"
                          fill="none"
                          stroke="currentColor"
                          stroke-width="2"
                          stroke-linecap="round"
                          stroke-linejoin="round"
                          class="feather feather-eye-off cursor-pointer"
                          size="14px"
                        >
                          <path
                            d="M17.94 17.94A10.07 10.07 0 0 1 12 20c-7 0-11-8-11-8a18.45 18.45 0 0 1 5.06-5.94M9.9 4.24A9.12 9.12 0 0 1 12 4c7 0 11 8 11 8a18.5 18.5 0 0 1-2.16 3.19m-6.72-1.07a3 3 0 1 1-4.24-4.24"
                          ></path>
                          <line x1="1" y1="1" x2="23" y2="23"></line>
                        </svg>
                        <svg
                          xmlns="http://www.w3.org/2000/svg"
                          v-if="passwordFieldType != 'password'"
                          width="14px"
                          height="14px"
                          viewBox="0 0 24 24"
                          fill="none"
                          stroke="currentColor"
                          stroke-width="2"
                          stroke-linecap="round"
                          stroke-linejoin="round"
                          class="feather feather-eye cursor-pointer"
                          size="14px"
                        >
                          <path d="M1 12s4-8 11-8 11 8 11 8-4 8-11 8-11-8-11-8z"></path>
                          <circle cx="12" cy="12" r="3"></circle>
                        </svg>
                      </b-input-group-append>
                    </b-input-group>
                    <small class="text-danger">{{
                      errors.password ? errors.password[0] : ""
                    }}</small>
                  </b-form-group>

                  <b-form-group>
                    <div class="d-flex justify-content-between">
                      <label for="cpassword"
                        >Confirm Password <span class="text-danger"> *</span></label
                      >
                    </div>
                    <b-input-group
                      class="input-group-merge"
                      :class="errors.cpassword?.length > 0 ? 'is-invalid' : null"
                    >
                      <b-form-input
                        id="confirm-password"
                        v-model="cpassword"
                        :state="
                          errors.cpassword && errors.cpassword.length > 0 ? false : null
                        "
                        @input="checkValidation('cpassword')"
                        @blur="checkValidation('cpassword')"
                        class="text-transform-none form-control-merge"
                        :type="newPasswordFieldType"
                        name="confirm-password"
                        placeholder="Enter Confirm Password"
                      />
                      <b-input-group-append is-text @click="toggleNewPasswordVisibility">
                        <svg
                          xmlns="http://www.w3.org/2000/svg"
                          v-if="newPasswordFieldType === 'password'"
                          width="14px"
                          height="14px"
                          viewBox="0 0 24 24"
                          fill="none"
                          stroke="currentColor"
                          stroke-width="2"
                          stroke-linecap="round"
                          stroke-linejoin="round"
                          class="feather feather-eye-off cursor-pointer"
                          size="14px"
                        >
                          <path
                            d="M17.94 17.94A10.07 10.07 0 0 1 12 20c-7 0-11-8-11-8a18.45 18.45 0 0 1 5.06-5.94M9.9 4.24A9.12 9.12 0 0 1 12 4c7 0 11 8 11 8a18.5 18.5 0 0 1-2.16 3.19m-6.72-1.07a3 3 0 1 1-4.24-4.24"
                          ></path>
                          <line x1="1" y1="1" x2="23" y2="23"></line>
                        </svg>
                        <svg
                          xmlns="http://www.w3.org/2000/svg"
                          v-if="newPasswordFieldType != 'password'"
                          width="14px"
                          height="14px"
                          viewBox="0 0 24 24"
                          fill="none"
                          stroke="currentColor"
                          stroke-width="2"
                          stroke-linecap="round"
                          stroke-linejoin="round"
                          class="feather feather-eye cursor-pointer"
                          size="14px"
                        >
                          <path d="M1 12s4-8 11-8 11 8 11 8-4 8-11 8-11-8-11-8z"></path>
                          <circle cx="12" cy="12" r="3"></circle>
                        </svg>
                      </b-input-group-append>
                    </b-input-group>
                    <small class="text-danger">{{
                      errors.cpassword ? errors.cpassword[0] : ""
                    }}</small>
                  </b-form-group>

                  <!-- submit buttons -->
                  <center>
                    <b-button type="submit" variant="primary" class="login-btn btn-block" block>
                      Set Password
                    </b-button>
                    <!-- <b-button variant="primary"  class="login-btn btn-block" block v-if="!isBtnEnabled && !isSubmit"
                      @click="formValidate()">
                      Set Password1
                    </b-button> -->
                  </center>
                </b-form>
              </template>
            </b-card>
            <!-- <p class="verification-label">or</p>
            <center>
              <b-button class="forgot-login-btn" block @click="resetPage()">
                Login
              </b-button>
            </center> -->
          </div>
        </div>
      </b-col>
    </b-row>
  </div>
</template>

<script>
import {
  BRow,
  BImg,
  BCol,
  BButton,
  BForm,
  BFormInput,
  BFormGroup,
  BCard,
  BLink,
  BCardTitle,
  BCardText,
  BInputGroup,
  BInputGroupAppend,
  BFormCheckbox,
  BAlert,
  BSpinner,
} from "bootstrap-vue";
import VuexyLogo from "@core/layouts/components/Logo.vue";
import Auth from "@/apis/Auth";
import ToastificationContent from "@core/components/toastification/ToastificationContent.vue";
import {
  togglePasswordVisibility,
  toggleNewPasswordVisibility,
} from "@core/mixins/ui/forms";
import useJwt from "@/auth/jwt/useJwt";
import { initialAbility } from "@/libs/acl/config";
import store from "@/store/index";
import { $themeConfig } from "@themeConfig";
import { useToast } from "vue-toastification";
import { useRoute } from "vue-router";
const toast = useToast();
export default {
  components: {
    // BSV
    BRow,
    BImg,
    BCol,
    BButton,
    BForm,
    BFormInput,
    BFormGroup,
    BCard,
    BCardTitle,
    BLink,
    VuexyLogo,
    BCardText,
    BInputGroup,
    BInputGroupAppend,
    BFormCheckbox,
    BAlert,
    BSpinner,
  },
  mixins: [togglePasswordVisibility, toggleNewPasswordVisibility],

  computed: {
    passwordToggleIcon() {
      return this.passwordFieldType === "password" ? "EyeOffIcon" : "EyeIcon";
    },
    newPasswordToggleIcon() {
      return this.newPasswordFieldType === "password" ? "EyeOffIcon" : "EyeIcon";
    },
    imgUrl() {
      if (store.state.appConfig.layout.skin === "dark") {
        // eslint-disable-next-line vue/no-side-effects-in-computed-properties
        this.downImg = this.errorIcon;
        return this.downImg;
      }
      return this.downImg;
    },
  },
  mounted() {
    const router = useRoute();
    this.logout();
    this.token = router?.params?.token;
    Auth.setPasswordCheck({
      token: this.token,
    })
      .then((response) => {
        const data = response.data;
        if (data.status == true) {
          this.pageView = 1;
        } else {
          this.pageView = 0;
        }
      })
      .catch((error) => {
        toast({
          component: ToastificationContent,
          props: {
            title: "Error",
            icon: "AlertCircleIcon",
            text: "Something went wrong. Please try later.",
            variant: "danger",
          },
        });
      });
  },
  data() {
    const { appLogoImage, bgImgOne, appBodyBG, errorSvg, errorIcon } = $themeConfig.app;
    return {
      errors: [],
      appLogoImage,
      bgImg: appBodyBG,
      bgImgOne,
      downImg: errorSvg,
      errorIcon: errorIcon,
      password: "",
      cpassword: "",
      isSubmit: false,
      isBtnEnabled: false,
      pageView: 1,
      token: "",
    };
  },
  methods: {
    checkValidation(field = "*") {
      if (field == "*" || field == "password") {
        if (!this.password) {
          this.errors["password"] = ["Please enter Password"];
        } else if (this.password.length < 6) {
          this.errors["password"] = ["Password must be at least 6 characters"];
        } else {
          delete this.errors["password"];
        }
      }

      if (field == "*" || field == "cpassword") {
        if (!this.cpassword) {
          this.errors["cpassword"] = ["Please enter Confirm Password"];
        } else if (this.password != this.cpassword) {
          this.errors["cpassword"] = ["Confirm Password does not match with Password"];
        } else {
          delete this.errors["cpassword"];
        }
      }

      this.isBtnEnabled = Object.keys(this.errors).length === 0;
      return Object.keys(this.errors).length === 0;
    },
    checkInput() {
      // if(this.checkValidation()){
      // this.isBtnEnabled = true;
      // } else {
      //   this.isBtnEnabled = false;
      // }
    },
    resetPage() {
      this.$router.push({
        name: "login",
      });
    },
    formValidate() {
      this.checkValidation();
    },
    login() {
      // this.$refs.setPasswordForm.validate().then((success) => {
      if (this.checkValidation()) {
        this.isSubmit = true;
        Auth.setPassword({
          token: this.token,
          password: this.password,
          confirm_password: this.cpassword,
        })
          .then((response) => {
            const data = response.data;
            if (data.status == true) {
              this.isSubmit = false;
              this.$router
                .push({
                  name: "login",
                })
                .then(() => {
                  toast({
                    component: ToastificationContent,
                    props: {
                      variant: "success",
                      icon: "CheckCircleIcon",
                      title: data.title,
                      text: data.message,
                    },
                  });
                });
            } else {
              if (data.errors) {
                this.errors = data.errors;
              } else {
                toast({
                  component: ToastificationContent,
                  props: {
                    title: data.title,
                    icon: "AlertCircleIcon",
                    text: data.message,
                    variant: "danger",
                  },
                });
              }
              this.isSubmit = false;
            }
          })
          .catch((error) => {
            toast({
              component: ToastificationContent,
              props: {
                title: "Error",
                icon: "AlertCircleIcon",
                text: "Something went wrong. Please try later.",
                variant: "danger",
              },
            });
            this.isSubmit = false;
          });
      }
      // });
    },
    logout() {
      // Remove userData from localStorage
      // ? You just removed token from localStorage. If you like, you can also make API call to backend to blacklist used token
      localStorage.removeItem(useJwt.jwtConfig.storageTokenKeyName);
      localStorage.removeItem(useJwt.jwtConfig.storageRefreshTokenKeyName);

      // Remove userData from localStorage
      localStorage.removeItem("userData");

      // Reset ability
      this.$ability.update(initialAbility);
    },
  },
};
</script>

<style lang="scss"></style>
